lexer grammar SpecificationLexer;

// Must be able to contain identifiers from any frontend, so it's fine to over-approximate valid identifiers a bit.
LANG_ID_ESCAPE: '`' ~[`]+ '`';

VAL_PREDICATE: 'predicate';
VAL_INTEGER: 'integer';
VAL_REAL: 'real';
VAL_BOOL: 'bool';

VAL_PURE: 'pure';

VAL_AXIOM: 'axiom';
VAL_AXIOMATIC: 'axiomatic';
VAL_INDUCTIVE: 'inductive';
VAL_LEMMA: 'lemma';
VAL_LOGIC: 'logic';

VAL_MODIFIES: 'modifies';
VAL_ACCESSIBLE: 'accessible';
VAL_ASSIGNS: 'assigns';
VAL_ASSUMES: 'assumes';
VAL_DECREASES: 'decreases';
VAL_REQUIRES: 'requires';
VAL_ENSURES: 'ensures';
VAL_INVARIANT: 'invariant';
VAL_LOOP_INVARIANT: 'loop_invariant';
VAL_LOOP_ASSIGNS: 'loop_assigns';
VAL_LOOP_VARIANT: 'loop_variant';
VAL_SIGNALS: 'signals';

VAL_EXC_BEHAVIOR: 'exceptional_behavior';
VAL_EXC_BEHAVIOUR: 'exceptional_behaviour';
VAL_NORMAL_BEHAVIOR: 'normal_behavior';
VAL_NORMAL_BEHAVIOUR: 'normal_behaviour';
VAL_BEHAVIOR: 'behavior';
VAL_BEHAVIOUR: 'behaviour';

VAL_GHOST: 'ghost';

FORALL: '\\forall';
EXISTS: '\\exists';
FRESH: '\\fresh';
OLD: '\\old';
AT: '\\at';
LABEL_HERE : 'Here';
LABEL_OLD : 'Old';
LABEL_PRE: 'Pre';
RESULT: '\\result';
NOTHING: '\\nothing';
EVERYTHING: '\\everything';
ABS: '\\abs';
SQRT: '\\sqrt';
CEIL: '\\ceil';
FLOOR: '\\floor';
REAL_ABS: '\\real_abs';
EXACT: '\\exact';
ROUND_ERROR: '\\round_error';
COS: '\\cos';
SIN: '\\sin';
TAN: '\\tan';
COSH: '\\cosh';
SINH: '\\sinh';
TANH: '\\tanh';
LOG: '\\log';
LOG10: '\\log10';
EXP: '\\exp';
ACOS: '\\acos';
ASIN: '\\asin';
ATAN: '\\atan';
ACOSH: '\\acosh';
ASINH: '\\asinh';
ATANH: '\\atanh';
POW: '\\pow';
ATAN2: '\\atan2';
PI: '\\pi';
E: '\\e';
HYPOT: '\\hypot';

IMPLIES: '==>';
EQUIVALENCE: '<==>';
RANGE_TO: '..';