lexer grammar SpecLexer;

LANG_ID_ESCAPE: '`' ~[`]+ '`';


VAL_PURE: 'pure';


VAL_AXIOM: 'axiom';
VAL_INVARIANT: 'invariant';
VAL_INITIALLY: 'initially';
VAL_READABLE: 'readable';
VAL_WRITABLE: 'writable';
VAL_MONITORS_FOR: 'monitors_for';

VAL_ALSO: 'also';
VAL_OLD: 'old';
VAL_FORALL: 'forall';
VAL_LOOP_MODIFIES: 'loop_modifies';
VAL_LOOP_ASSIGNS: 'loop_assigns';
VAL_MODIFIES: 'modifies';
VAL_MODIFIABLE: 'modifiable';
VAL_ASSIGNABLE: 'assignable';
VAL_ASSIGNS: 'assigns';
VAL_ACCESSIBLE: 'accessible';
VAL_REQUIRES: 'requires';
VAL_PRE: 'pre';
VAL_POST: 'post';
VAL_ENSURES: 'ensures';
VAL_DIVERGES: 'diverges';
VAL_LOOP_INVARIANT: 'loop_invariant';
VAL_MAINTAINING: 'maintaining';
VAL_DECREASES: 'decreases';
VAL_LOOP_DECREASES: 'loop_decreases';
VAL_DECREASING: 'decreasing';
VAL_SIGNALS_ONLY: 'signals_only';
VAL_SIGNALS: 'signals';
VAL_EXSURES: 'exsures';
VAL_MEASURED_BY: 'measured_by';

VAL_BEHAVIOR: 'behavior';
VAL_BEHAVIOUR: 'behaviour';
VAL_NORMAL_BEHAVIOR: 'normal_behavior';
VAL_NORMAL_BEHAVIOUR: 'normal_behaviour';
VAL_EXCEPTIONAL_BEHAVIOR: 'exceptional_behavior';
VAL_EXCEPTIONAL_BEHAVIOUR: 'exceptional_behaviour';

VAL_ASSUME: 'assume';
VAL_GHOST: 'ghost';
VAL_SET: 'set';
VAL_UNREACHABLE: 'unreachable';


FORALL: '\\forall';
EXISTS: '\\exists';
SUM: '\\sum';
OLD: '\\old';
TYPEOF: '\\typeof';
RESULT: '\\result';
PRE: '\\pre';
NOT_ASSIGNED: '\\not_assigned';
NOT_MODIFIED: '\\not_modified';
ONLY_ACCESSED: '\\only_accessed';
ONLY_ASSIGNED: '\\only_assigned';
ONLY_CALLED: '\\only_called';
ONLY_CAPTURED: '\\only_captured';
FRESH: '\\fresh';
REACH: '\\reach';
DURATION: '\\duration';
SPACE: '\\space';
WORKING_SPACE: '\\working_space';
NONNULLELEMENTS: '\\nonnullelements';
ELEMTYPE: '\\elemtype';
TYPE: '\\type';
LOCKSET: '\\lockset';
MAX: '\\max';
IS_INITIALIZED: '\\is_initialized';
INVARIANT_FOR: '\\invariant_for';
LBLNEG: '\\lblneg';
LBLPOS: '\\lblpos';
SAME: '\\same';
NOTHING: '\\nothing';
EVERYTHING: '\\everything';
NOT_SPECIFIED: '\\not_specified';
MIN: '\\min';
NUM_OF: '\\num_of';
PRODUCT: '\\product';
COUNT: '\\count';
TYPE_TYPE: '\\TYPE';
REP: '\\rep';
PEER: '\\peer';
READONLY: '\\readonly';
VAL_REP: 'rep';
VAL_PEER: 'peer';
VAL_READONLY: 'readonly';

NON_NULL: 'non_null';
NULLABLE: 'nullable';
NULLABLE_BY_DEFAULT: 'nullable_by_default';
HELPER: 'helper';
MONITORED: 'monitored';
MODEL: 'model';
INSTANCE: 'instance';
SPEC_PUBLIC: 'spec_public';
SPEC_PROTECTED: 'spec_protected';
SPEC_JAVA_MATH: 'spec_java_math';
SPEC_SAFE_MATH: 'spec_safe_math';
SPEC_BIGINT_MATH: 'spec_bigint_math';
CODE_JAVA_MATH: 'code_java_math';
CODE_SAFE_MATH: 'code_safe_math';
CODE_BIGINT_MATH: 'code_bigint_math';

EQUIVALENT: '<==>';
NOT_EQUIVALENT: '<=!=>';
IMPLIES: '==>';
BACK_IMPLIES: '<==';
RANGE_TO: '..';
