ThisBuild / version := "0.1"
ThisBuild / scalaVersion := "3.1.0"

enablePlugins(BuildInfoPlugin)
//enablePlugins(JavaAppPackaging)

libraryDependencies += "org.scalatest" %% "scalatest" % "3.2.10" % "test"
libraryDependencies += "org.rogach" %% "scallop" % "4.1.0"

lazy val core = (project in file("."))
  .aggregate(VerCorsParser, KrakatoaParser, OpenJMLParser)
  .dependsOn(VerCorsParser, KrakatoaParser, OpenJMLParser)
  .settings(
    name := "Annotation Translator",
//    Universal / mappings += {
//      val jar = (Compile / packageBin).value
//      jar -> ("target/AnnotationTranslator.jar")
//    }
    buildInfoKeys := Seq[BuildInfoKey](name, version, scalaVersion, sbtVersion),
    buildInfoPackage := "buildinfo",
    assembly / assemblyJarName := "AnnotationTranslator.jar",
  )

lazy val VerCorsParser = (project in file("VerCors"))
  .settings(
    name := "VerCors parser",
  )

lazy val KrakatoaParser = (project in file("Krakatoa"))
  .settings(
    name := "Krakatoa parser",
  )

lazy val OpenJMLParser = (project in file("OpenJML"))
  .settings(
    name := "OpenJML parser"
  )

//lazy val AntlrVersion     = "4.9.2"
//
//lazy val root = (project in file("."))
////  .enablePlugins(Antlr4Plugin)
//  .settings(
//    libraryDependencies ++= Seq(
//      "org.antlr"     % "antlr4-runtime"     % AntlrVersion,
//    ),
////    antlr4GenListener in Antlr4 := true,
////    antlr4GenVisitor in Antlr4 := true
//  )
//
//lazy val antlrTask = taskKey[Seq[File]]("Generate visitor from ANTLR grammars")
//
//antlrTask := {
//  val cp = (dependencyClasspath in Compile).value.files
//  val src = file(".") / "scala" / "languages" / "OpenJML" / "parser"
//  val target = src / "generated"
//  val log = streams.value.log
//
//  val genTarget = src / "JavaParser.g4"
//
//  val exitCode = scala.sys.process.Process("java", Seq(
//          "-cp", Path.makeString(cp),
//          "org.antlr.v4.Tool",
//          "-o", target.toString,
//          "-visitor",
//          genTarget.toString
//        ) ) ! log
//
//  if (exitCode != 0) {
//    sys.error(s"Antlr4 failed with exit code $exitCode")
//  }
//
//
//  // Grab all the generated files as our output
//  (target ** "*.java").get ++ (target ** "*.scala").get

//}
