package generic

import generic.syntaxTree.{JmlModifierBlock, Modifier, StringNode, TreeNode}

object Helper {

  def commentNode(node: TreeNode, firstKeyword: TreeNode, err_text: String): String = {
    var text = ""
    if(err_text != "") {
      text += getNewlines(node, firstKeyword)
      text += "// " + err_text
    }
    val nodeText = node.toString
    var replaced = nodeText.replace(System.lineSeparator(), System.lineSeparator()+"//")
    if(nodeText.endsWith(System.lineSeparator())) {
      replaced = replaced.dropRight(2)
    } else {
      replaced += System.lineSeparator()
    }
    text += replaced.replace("@", " ")
    text
  }

  def commentUnknownNode(node: TreeNode, err_text: String): String = {
    var text = ""
    if(err_text != "") {
      text += getNewlines(node)
      text += "// " + err_text
    }
    val nodeText = node.toString
    var replaced = nodeText.replace(System.lineSeparator(), System.lineSeparator()+"//")
    if(nodeText.endsWith(System.lineSeparator())) {
      replaced = replaced.dropRight(2)
    } else {
      replaced += System.lineSeparator()
    }
    text += replaced.replace("@", " ")
    text
  }

  def getNewlines(node: TreeNode, firstKeyword: TreeNode): String = {
    val text = node.precedingWhitespace + firstKeyword.precedingWhitespace
    val mat = """\s*""".r.findPrefixMatchOf(text)
    mat match {
      case Some(value) => value.group(0)
      case None => ""
    }
  }

  def getNewlines(node: TreeNode): String = {
    val text = node.precedingWhitespace
    val mat = """\s*""".r.findPrefixMatchOf(text)
    mat match {
      case Some(value) => value.group(0)
      case None => ""
    }
  }

  def findModifier(modifiers: List[Modifier], typeCheck: Modifier=>Boolean): Boolean = {
    def findModifier(node: Modifier, typeCheck: Modifier => Boolean): Boolean = {
      node match {
        case n: Modifier if typeCheck(n) => true
        case j: JmlModifierBlock => j.modifiers.exists(x => findModifier(x, typeCheck))
        case _ => false
      }
    }
    
    modifiers.exists(x => findModifier(x, typeCheck))
  }
}
