package generic

case class SourceLocation(filename: String, fromLine: Int, var toLine:Int = -1) {

  override def toString: String = {
    var filestring = filename
    if (filename.isEmpty) {
      filestring = " in unknown file"
    } else {
      filestring = s" in file \"${filename}\""
    }
    var linestring = ""
    if (fromLine != -1) {
      if (toLine == -1) {
        linestring = s" on line ${fromLine}"
      } else {
        linestring = s" from line ${fromLine} to line ${toLine}"
      }
    }
    filestring + linestring
  }
}
