package generic.syntaxTree

import generic.SourceLocation

trait TreeNode {
  val nodeType: NodeType
  var srcLocation: SourceLocation
  var precedingWhitespace: String
  var trailingWhitespace: String = ""

  override def toString: String = {
    precedingWhitespace + stringRepresentation + trailingWhitespace
  }

  def stringRepresentation: String
  
  def copyWhitespace(node: TreeNode): Unit = {
    precedingWhitespace = node.precedingWhitespace
    trailingWhitespace = node.trailingWhitespace
  }
  
  def isIRNode: Boolean = nodeType==NodeType.IR || nodeType == NodeType.ANY
  def isKrakatoaNode: Boolean = nodeType==NodeType.KRAKATOA || nodeType == NodeType.ANY
  def isOpenJMLNode: Boolean = nodeType==NodeType.OPENJML || nodeType == NodeType.ANY
  def isVerCorsNode: Boolean = nodeType==NodeType.VERCORS || nodeType == NodeType.ANY
}

enum NodeType:
  case ANY, IR, KRAKATOA, OPENJML, VERCORS
