package intermediateRepresentation.syntaxTree

import generic.SourceLocation

case class StringNode(var text: String,
                      var srcLocation: SourceLocation,
                      var precedingWhitespace: String="",
                      pTrailingWhitespace: String="")
      extends generic.syntaxTree.StringNode with IrTreeNode with Expression
{
  trailingWhitespace = pTrailingWhitespace
}

class ModifierStringNode (pText: String, pSrcLocation: SourceLocation, precedingWhitespace: String="")
      extends StringNode(pText, pSrcLocation, precedingWhitespace) with Modifier
object ModifierStringNode {
  def unapply(modifier: ModifierStringNode): Some[(String,
                                                    SourceLocation,
                                                    String)] = {
    Some(modifier.text,
          modifier.srcLocation,
          modifier.precedingWhitespace)
  }
}
