package languages.Krakatoa

import generated.KrakatoaParserBaseVisitor
import org.antlr.v4.runtime.CommonTokenStream
import org.antlr.v4.runtime.tree.TerminalNode
import scala.jdk.CollectionConverters.ListHasAsScala

class ParserPrintVisitor(tokens: CommonTokenStream, var skipFirstHidden: Boolean=false) extends KrakatoaParserBaseVisitor[String] {

  override def visitTerminal(node:TerminalNode): String = {
    var res = node.toString
    val idx = node.getSymbol.getTokenIndex
    if (skipFirstHidden) {
      skipFirstHidden = false
    } else {
      val hiddenTokens = tokens.getHiddenTokensToLeft(idx).asScala
      if (hiddenTokens != null) {
        res = hiddenTokens.map(_.getText).mkString + res
      }
    }
    res
  }

  override def defaultResult(): String = ""

  override def aggregateResult(aggregate: String, nextResult: String): String = {
    aggregate + nextResult
  }
}
