public class BinarySearch {
    
    /*@ requires sortedArray!=null; */
      
      //@ requires (\let  boolean containsValue = (\exists int i; 0 <= i && i < sortedArray.length; sortedArray[i] == value); sortedArray != null && 0 < sortedArray.length && sortedArray.length < Integer.MAX_VALUE);
    //@ requires (\let  boolean containsValue = (\exists int i; 0 <= i && i < sortedArray.length; sortedArray[i] == value); (\forall int i; 0 <= i && i < sortedArray.length; (\forall int j; i < j && j < sortedArray.length; sortedArray[i] <= sortedArray[j])));
    //@ ensures (\let  boolean containsValue = \old( (\exists int i; 0 <= i && i < sortedArray.length; sortedArray[i] == value)); (containsValue) ==( 0 <= \result && \result < sortedArray.length));
    //@ ensures (\let  boolean containsValue = \old( (\exists int i; 0 <= i && i < sortedArray.length; sortedArray[i] == value));( !containsValue) ==( \result == -1));
    //@ pure
    public static int search(int[] sortedArray, int value) {
        //@ ghost boolean containsValue = (\exists int i; 0 <= i && i < sortedArray.length; sortedArray[i] == value);
        if (value < sortedArray[0]) return -1;
        if (value > sortedArray[sortedArray.length-1]) return -1;
        int lo = 0;
        int hi = sortedArray.length-1;
        //@ loop_invariant 0 <= lo && lo < sortedArray.length && 0 <= hi && hi < sortedArray.length;
        //@ loop_invariant containsValue ==> sortedArray[lo] <= value && value <= sortedArray[hi];
        //@ loop_invariant (\forall int i; 0 <= i && i < lo; sortedArray[i] < value);
        //@ loop_invariant (\forall int i; hi < i && i < sortedArray.length; value < sortedArray[i]);
        //@ decreases hi - lo;
        while (lo <= hi) {
            int mid = lo + (hi-lo)/2;
            if (sortedArray[mid] == value) {
                return mid;
            } else if (sortedArray[mid] < value) {
                lo = mid+1;
            } else {
                hi = mid-1;
            }
        }
        return -1;
    }
}
