// -*- tab-width:2 ; indent-tabs-mode:nil -*-
//:: cases Counter
//:: tools silicon
//:: verdict Pass
/*
check with vct --silicon Counter.java
*/
 /*@ nullable_by_default */ class Counter {
  private /*@ spec_public */ int val;

  /*@ 
    // cannot express permission amount exactly. commented out
//
//  /*  
//    requires IR_permission_expression(val, 1);
    ensures val==\old(val)+1;
   */
    //@ assignable val;

   /*@ spec_public */ void incr(){
    val = val+1;
  }
  
  /*@ 
	requires n>=0;
    ensures val==\old(val)+n; 
   */
    //@ assignable val;

   /*@ spec_public */ void incr_by_n(int n)
  {
    int tmp=n;
    /*@ 
      // cannot express permission amount exactly. commented out 
//      loop_invariant IR_permission_expression(val, 1);
      loop_invariant val+tmp==\old(val)+n && tmp>=0;
      loop_modifies val; 
     */
    while(tmp>0)
    {
      val=val+1;
      tmp=tmp-1;
    }
  }

  /*@ 
    requires n>=0;
    ensures c.val==\old(c.val)+n; 
   */
    //@ assignable c.val;

  static /*@ spec_public */ void incr_static(Counter c,int n)
  {
    int tmp=n;
    /*@ 
      // cannot express permission amount exactly. commented out 
//      loop_invariant IR_permission_expression(c.val, 1);
      loop_invariant c.val+tmp==\old(c.val)+n && tmp>=0;
      loop_modifies c.val; 
     */
    while(tmp>0)
    {
      c.incr();
      tmp=tmp-1;
    }
  }

  static /*@ spec_public */ void main(){
    Counter c=new Counter();
    assert c.val==0;
  }
}
