public /*@ nullable_by_default */ class CounterVerifast {

   /*@ spec_public */ int value;

  //@ // cannot express permissions in post-conditions. commented out
//
//  //  ensures IR_permission_expression(this.value,  1);

  //@ ensures this.value == v;
   /*@ spec_public */ CounterVerifast(int v)
  {
    this.value=v;
  }
  
  //@ // cannot express permission amount exactly. commented out
//  
//  //  requires IR_permission_expression(v.value,  1);
 // cannot express permissions in post-conditions. commented out ensures IR_permission_expression(v.value,  1);

  //@ // cannot express permissions in post-conditions. commented out  //  ensures IR_permission_expression(this.value,  1);

  //@ ensures v.value == \old(v.value) && this.value == \old(v.value);

    //@ assignable v.value;
   /*@ spec_public */ CounterVerifast(CounterVerifast v)
  {
    this.value=v.value;
  }

  //@ // cannot express permissions in post-conditions. commented out
//
//  //  ensures IR_permission_expression(this.value,  1);

  //@ ensures this.value == v+b;
   /*@ spec_public */ CounterVerifast(int v,int b)
  {
    this.value=v+b;
  }

  //@ // cannot express permission amount exactly. commented out
//
//  //  requires IR_permission_expression(this.value,  1); // cannot express permissions in post-conditions. commented out ensures IR_permission_expression(this.value,  1);

  //@ ensures this.value == \old(this.value) + 1;

    //@ assignable this.value;
   /*@ spec_public */ void increment()
  {
    this.value = this.value + 1;
  }
  
  //@ // cannot express permission amount exactly. commented out
//  
//  //  requires IR_permission_expression(this.value,  1); // cannot express permissions in post-conditions. commented out ensures IR_permission_expression(this.value,  1);

  //@ ensures this.value == \old(this.value) + x;

    //@ assignable this.value;
   /*@ spec_public */ void add(int x)
  {
    this.value = this.value + x;
  }
  
  //@ // cannot express permission amount exactly. commented out
//  
//  //  requires IR_permission_expression(this.value,  1) ** IR_permission_expression(x.value,  1); // cannot express permissions in post-conditions. commented out ensures IR_permission_expression(this.value,  1) ** IR_permission_expression(x.value,  1);

  //@ ensures this.value == \old(this.value) + \old(x.value) && x.value == \old(x.value);

    //@ assignable this.value;

    //@ assignable x.value;
   /*@ spec_public */ void add(CounterVerifast x)
  {
    add(x.value);
  }

  //@ // cannot express permission amount exactly. commented out
//
//  //  requires IR_permission_expression(c1.value,  1) ** IR_permission_expression(c2.value,  1);
 // cannot express permissions in post-conditions. commented out ensures IR_permission_expression(c1.value,  1) ** IR_permission_expression(c2.value,  1);

  //@ ensures c1.value == \old(c2.value) && c2.value == \old(c1.value);

    //@ assignable c1.value;

    //@ assignable c2.value;
  static /*@ spec_public */ void swap(CounterVerifast c1, CounterVerifast c2)
  {
    int tmp = c1.value;
    c1.value = c2.value;
    c2.value = tmp;
  }

  //@ requires true;
  //@ ensures true;
  public static void main(String[] args)
  {
    CounterVerifast c1 = new CounterVerifast(0);
    CounterVerifast c2 = new CounterVerifast(5);
    CounterVerifast c3 = new CounterVerifast(5,5);
    CounterVerifast c4= new CounterVerifast(c2);
    c1.increment();
    CounterVerifast.swap(c1, c2);
    int tmp = c2.value;
    //@ assert tmp == 1;
    tmp=c3.value;
    //@ assert tmp==10;
    tmp=c4.value;
    int tmp2=c1.value;
    //@ assert tmp==tmp2;
    
    c1.add(10);
    tmp=c1.value;
    //@ assert tmp==15;
    
    c1.add(c2);
    tmp=c1.value;
    //@ assert tmp==16;
  }
}
