// Issue: MIN_VALUE and MAX_VALUE cannot be equal to the actual MIN and MAX values.
public /*@ nullable_by_default */ class SumMax {
   /*@ spec_public */ int MIN_VALUE;
   /*@ spec_public */ int MAX_VALUE;
  
   /*@ spec_public */ SumMax() {
    MIN_VALUE = -2147483647; // off-by-one, see issue #640
    MAX_VALUE = 2147483646; // off-by-one, see issue #640
  }

  //@ requires a != null;
  //@ requires a.length > 0;
  //@ // cannot express permission amount exactly. commented out  //  requires (\forall int i; i >= 0 && i < a.length; IR_permission_expression(a[i],  read));

  //@ // cannot express permission amount exactly. commented out  //  requires IR_permission_expression(MIN_VALUE,  read);

  //@ // cannot express permission amount exactly. commented out  //  requires IR_permission_expression(MAX_VALUE,  read);

  //@ // cannot express permissions in post-conditions. commented out  //  ensures IR_permission_expression(MAX_VALUE,  read);

  //@ // cannot express permissions in post-conditions. commented out  //  ensures IR_permission_expression(MIN_VALUE,  read);

  //@ // cannot express permissions in post-conditions. commented out  //  ensures (\forall int i; i >= 0 && i < a.length; IR_permission_expression(a[i],  read));


    //@ assignable  a[0..a.length];

    //@ assignable MIN_VALUE;

    //@ assignable MAX_VALUE;
   /*@ spec_public */ void m(int[] a) {
    int sum = 0;
    int max = a[0];

    /*@ // cannot express permission amount exactly. commented out loop_invariant (\forall int i; i >= 0 && i < a.length; IR_permission_expression(a[i],  read));
      loop_modifies  a[0..a.length];*/
    /*@ // cannot express permission amount exactly. commented out loop_invariant IR_permission_expression(MIN_VALUE,  read);
      loop_modifies MIN_VALUE;*/
    /*@ // cannot express permission amount exactly. commented out loop_invariant IR_permission_expression(MAX_VALUE,  read);
      loop_modifies MAX_VALUE;*/
    //@ loop_invariant 0 <= i && i <= a.length;
    //@ loop_invariant sum <= i * max;  // Assertion to be proved
    for (int i=0; i<a.length; i++) {
      //@ assume MIN_VALUE <= sum + a[i] && sum + a[i] <= MAX_VALUE; // Just assume we never overflow
      sum += a[i];
      if (max < a[i]) max = a[i];
    }
  }

}

