public class CounterVerifast {

  int value;

  //@ ensures Perm(this.value, 1);
  //@ ensures this.value == v;
  CounterVerifast(int v)
  {
    this.value=v;
  }
  
  //@ requires Perm(v.value, 1); ensures Perm(v.value, 1);
  //@ ensures Perm(this.value, 1);
  //@ ensures v.value == \old(v.value) ** this.value == \old(v.value);
  CounterVerifast(CounterVerifast v)
  {
    this.value=v.value;
  }

  //@ ensures Perm(this.value, 1);
  //@ ensures this.value == v+b;
  CounterVerifast(int v,int b)
  {
    this.value=v+b;
  }

  //@ requires Perm(this.value, 1); ensures Perm(this.value, 1);
  //@ ensures this.value == \old(this.value) + 1;
  void increment()
  {
    this.value = this.value + 1;
  }
  
  //@ requires Perm(this.value, 1); ensures Perm(this.value, 1);
  //@ ensures this.value == \old(this.value) + x;
  void add(int x)
  {
    this.value = this.value + x;
  }
  
  //@ requires Perm(this.value, 1) ** Perm(x.value, 1); ensures Perm(this.value, 1) ** Perm(x.value, 1);
  //@ ensures this.value == \old(this.value) + \old(x.value) ** x.value == \old(x.value);
  void add(CounterVerifast x)
  {
    add(x.value);
  }

  //@ requires Perm(c1.value, 1) ** Perm(c2.value, 1); ensures Perm(c1.value, 1) ** Perm(c2.value, 1);
  //@ ensures c1.value == \old(c2.value) ** c2.value == \old(c1.value);
  static void swap(CounterVerifast c1, CounterVerifast c2)
  {
    int tmp = c1.value;
    c1.value = c2.value;
    c2.value = tmp;
  }

  //@ requires true;
  //@ ensures true;
  public static void main(String[] args)
  {
    CounterVerifast c1 = new CounterVerifast(0);
    CounterVerifast c2 = new CounterVerifast(5);
    CounterVerifast c3 = new CounterVerifast(5,5);
    CounterVerifast c4= new CounterVerifast(c2);
    c1.increment();
    CounterVerifast.swap(c1, c2);
    int tmp = c2.value;
    //@ assert tmp == 1;
    tmp=c3.value;
    //@ assert tmp==10;
    tmp=c4.value;
    int tmp2=c1.value;
    //@ assert tmp==tmp2;
    
    c1.add(10);
    tmp=c1.value;
    //@ assert tmp==15;
    
    c1.add(c2);
    tmp=c1.value;
    //@ assert tmp==16;
  }
}
