public class MaxByElimination {

  //@ requires a != null;
  //@ requires (\forall* int i; i >= 0 && i < a.length; Perm(a[i], read));
  //@ requires a.length > 0;
  //@ ensures (\forall* int i; i >= 0 && i < a.length; Perm(a[i], read));
  //@ ensures 0 <= \result && \result < a.length;
  //@ ensures (\forall int i; 0 <= i && i < a.length; a[i] <= a[\result]);
  public static int max(int[] a) {
    int x = 0;
    int y = a.length-1;

    //@ loop_invariant (\forall* int i; i >= 0 && i < a.length; Perm(a[i], read));
    //@ loop_invariant 0 <= x && x <= y && y < a.length;
    // So far either a[y] is the largest or a[x] is the largest of everything beyond x and beyond y (not including a[x] and a[y])
    /*@ loop_invariant ((\forall int i; 0<=i && i<x; a[i] <= a[y]) && (\forall int i; y < i && i < a.length; a[i] <= a[y]))
	               ||  ((\forall int i; 0<=i && i<x; a[i] <= a[x]) && (\forall int i; y < i && i < a.length; a[i] <= a[x]));
     */	
    //Not supported: decreases y-x;
    while (x != y) {
      if (a[x] <= a[y]) x++;
      else y--;
    }
    return x;
  }
}

