// Issue: Takes VERY LONG to verify (no clue if it actually verifies)
// This is Challenge 2A from VerifyThis 2019

public class Challenge2A2019 {

    //@ requires input != null;
    //@ requires Perm(input[*], read);
    //@ ensures \result != null;
    //@ ensures input != null;
    //@ ensures Perm(\result[*], 1);
    //@ ensures Perm(input[*], read);
    //@ ensures \result.length == input.length;
    //@ ensures (\forall int i; 0 <= i && i < \result.length; -1 <= \result[i] && \result[i] < i); // left-neighbor is to the left
    //@ ensures (\forall int i; 0 <= i && i < \result.length; \result[i] != -1 ==> input[\result[i]] < input[i]);// LN has smaller value
    //@ ensures (\forall int i; 0 <= i && i < \result.length; (\forall int j; \result[i] < j && j < i; input[j] >= input[i])); // LN is closest smaller value
    public int[] leftNeighbors(int[] input) {

        int[] left = new int[input.length];
        int[] stack = new int[input.length];
        int height = 0;

        //@ loop_invariant input != null;
        //@ loop_invariant Perm(input[*], read);
        //@ loop_invariant left != null;
        //@ loop_invariant Perm(left[*], 1);
        //@ loop_invariant stack != null; 
        //@ loop_invariant Perm(stack[*], 1);
        //@ loop_invariant 0 <= x && x <= input.length;
        //@ loop_invariant 0 <= height && height <= x;
        //@ loop_invariant (\forall int i; 0 <= i && i < x; -1 <= left[i] && left[i] < i);  // so far, all left-neighbors are to the left
        //@ loop_invariant (\forall int i; 0 <= i && i < x; left[i] != -1 ==> input[left[i]] < input[i]); // so far, all LNs have smaller values
        //@ loop_invariant (\forall int i; 0 <= i && i < x; (\forall int j; left[i] < j && j < i; input[j] >= input[i])); // so far, all LNs are closest smaller values
        //@ loop_invariant (\forall int i; 0 <= i && i < height; 0 <= stack[i] && stack[i] < x); // all stack values are legitimate positions
        //@ loop_invariant x > 0 ==> height > 0;
        //@ loop_invariant height > 0 ==> stack[height-1] == x-1; // x is always one more than top of stack (after the first iteration)
        //@ loop_invariant (\forall int i; 1 <= i && i < height; (\forall int j; stack[i-1] < j && j < stack[i]; input[j] >= input[stack[i]])); // items missing from stack are larger than something to their right
        //@ loop_invariant height > 0 ==> (\forall int j; 0 <= j && j < stack[0]; input[j] >= input[stack[0]]); // items missing from the stack in the first segment are larger than stack[0]
        // Not supported: loop_decreases input.length - x;
        for (int x=0; x<input.length; x++) {
            //@ loop_invariant input != null;
            //@ loop_invariant Perm(input[*], read);
            //@ loop_invariant left != null;
            //@ loop_invariant Perm(left[*], 1);
            //@ loop_invariant stack != null; 
            //@ loop_invariant Perm(stack[*], 1);
            //@ loop_invariant 0 <= height && height <= x;
            //@ loop_invariant (\forall int i; 0 <= i && i < x; -1 <= left[i] && left[i] < i);   // so far, all left-neighbors are to the left
            //@ loop_invariant (\forall int i; 0 <= i && i < height; 0 <= stack[i] && stack[i] < x);  // so far, all LNs have smaller values
            //@ loop_invariant (\forall int i; 1 <= i && i < height; (\forall int j; stack[i-1] < j && j < stack[i]; input[j] >= input[stack[i]]));  // so far, all LNs are closest smaller values
            //@ loop_invariant height > 0 ==> (\forall int j; stack[height-1] < j && j < x; input[j] >= input[x]); // Everything between top of stack and x is larger than va
            //@ loop_invariant height == 0 ==> (\forall int j; 0 <= j && j < x; input[j] >= input[x]); // If height is 0, everything to the left is smaller than value at current position
            //Not supported: loop_decreases height;
            while (height > 0 && input[stack[height-1]] >= input[x]) {
                height--;
            }

            if (height == 0) {
                left[x] = -1;
            } else {
                left[x] = stack[height-1];
            }
            stack[height++] = x;
        }
        return left;
    }
}
