package basic;

class Counter {
  /*@ invariant this != null; */
  /*@ spec_public */ private int val;

  /*@ modifies this.val; */
  /*@ ensures this.val - \old(this.val) - 1 == 0; */
  void incr(){
    val = val+1;
  }
  
  /*@ requires n == 0 || n == 2; */
  /*@ modifies this.val; */
  /*@ ensures this.val >= \old(this.val); */
  void incr_by_n(int n)
  {
    int tmp=n;
    while(tmp>0)
    {
      val=val+1;
      tmp=tmp-1;
    }
  }

  /*@ requires c != null; */
  /*@ requires c.val == 5 || c.val == 12; */
  /*@ requires n == 2; */
  /*@ modifies c.val; */
  /*@ ensures c.val == 7 || c.val == 14; */
  static void incr_static(Counter c,int n)
  {
    int tmp=n;
    while(tmp>0)
    {
      c.incr();
      tmp=tmp-1;
    }
  }

  /*@ modifies basic.Counter.$assertionsDisabled; */
  static void main(){
    Counter c=new Counter();
    assert c.val==0;
  }
}
