package basic;

class Counter {
  /*@ invariant this.val == 0 || this.val == 1 || this.val == 2; */
  /*@ spec_public */ private int val;

  /*@ requires this.val == 0 || this.val == 1; */
  /*@ modifies this.val; */
  /*@ ensures this.val == 1 || this.val == 2; */
  /*@ ensures this.val > \old(this.val); */
  void incr(){
    val = val+1;
  }
  
  /*@ requires this.val == 0; */
  /*@ requires n == -1244746321 || n == 0; */
  /*@ ensures this.val == 0; */
  void incr_by_n(int n)
  {
    int tmp=n;
    while(tmp>0)
    {
      val=val+1;
      tmp=tmp-1;
    }
  }

  /*@ requires c.val == 0; */
  /*@ requires n == 2; */
  /*@ modifies c.val; */
  /*@ ensures c.val == 2; */
  static void incr_static(Counter c,int n)
  {
    int tmp=n;
    while(tmp>0)
    {
      c.incr();
      tmp=tmp-1;
    }
  }

  /*@ modifies basic.Counter.$assertionsDisabled; */
  static void main(){
    Counter c=new Counter();
    assert c.val==0;
  }
}
