package basic;

class Counter {
  /*@ invariant this.val >= 0; */
  /*@ spec_public */ private int val;

  /*@ modifies this.val; */
  /*@ ensures this.val >= 1; */
  /*@ ensures this.val - \old(this.val) - 1 == 0; */
  void incr(){
    val = val+1;
  }
  
  /*@ requires this.val >= 1; */
  /*@ requires n >= 0; */
  /*@ modifies this.val; */
  /*@ ensures this.val >= 2; */
  /*@ ensures this.val >= \old(this.val); */
  void incr_by_n(int n)
  {
    int tmp=n;
    while(tmp>0)
    {
      val=val+1;
      tmp=tmp-1;
    }
  }

  /*@ requires c != null; */
  /*@ modifies c.val; */
  /*@ ensures c.val >= \old(c.val); */
  static void incr_static(Counter c,int n)
  {
    int tmp=n;
    while(tmp>0)
    {
      c.incr();
      tmp=tmp-1;
    }
  }

  /*@ modifies basic.Counter.$assertionsDisabled, args[*], args[].toString; */
  public static void main(String[] args){
    Counter c=new Counter();
    assert c.val==0;
  }
}
