package elim;

public class MaxByElimination {

  /*@ ensures (\forall int i; (0 <= i && i <= a.length-1) ==> (a[i] <= a[\result])); */
  /*@ ensures \result <= a.length-1; */
  /*@ ensures a[\result] > a[\result-1]; */
  public static int max(int[] a) {
    int x = 0;
    int y = a.length-1;

    while (x != y) {
      if (a[x] <= a[y]) x++;
      else y--;
    }
    return x;
  }
  
  
  
  public static void test_max() {
    java.util.Random rnd = new java.util.Random();
    int size = rnd.nextInt(100);
    int[] a = new int[size];
    for (int i = 0; i < size; i++) {
      int newElem = rnd.nextInt(5000);
      a[i] = newElem;
    }
    max(a);
  }
  
  /*@ requires args != null; */
  /*@ requires \typeof(args) == \type(java.lang.String[]); */
  /*@ requires (args.length == 0) && ((\forall int i; (0 <= i && i <= args.length-1) ==> (args[i] != null))); */
  /*@ ensures (args.length == 0) && ((\forall int i; (0 <= i && i <= args.length-1) ==> (args[i] != null))); */
  public static void main(String[] args) {
    for (int i = 0; i < 10; i++) {
      test_max();
    }
  }
}

